package se.softstuff.nb.nbdevbundlefinder;

import org.netbeans.api.settings.ConvertAsProperties;
import org.openide.awt.ActionID;
import org.openide.awt.ActionReference;
import org.openide.util.NbBundle;
import org.openide.windows.TopComponent;
import org.openide.util.NbBundle.Messages;

/**
 * Top component which displays something.
 */
@ConvertAsProperties(dtd = "-//se.softstuff.nb.nbdevbundlefinder//BundleImport//EN",
autostore = false)
@TopComponent.Description(preferredID = "BundleImportTopComponent",
//iconBase="SET/PATH/TO/ICON/HERE", 
persistenceType = TopComponent.PERSISTENCE_ALWAYS)
@TopComponent.Registration(mode = "editor", openAtStartup = false)
@ActionID(category = "Window", id = "se.softstuff.nb.nbdevbundlefinder.BundleImportTopComponent")
@ActionReference(path = "Menu/Window" /*
 * , position = 333
 */)
@TopComponent.OpenActionRegistration(displayName = "#CTL_BundleImportAction",
preferredID = "BundleImportTopComponent")
@Messages({
    "CTL_BundleImportAction=BundleImport",
    "CTL_BundleImportTopComponent=BundleImport Window",
    "HINT_BundleImportTopComponent=This is a BundleImport window"
})
public final class BundleImportTopComponent extends TopComponent {

    public BundleImportTopComponent() {
        initComponents();
        setName(Bundle.CTL_BundleImportTopComponent());
        setToolTipText(Bundle.HINT_BundleImportTopComponent());

    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        bundleChangeFileTextField = new javax.swing.JTextField();
        currentProjectFileTextField = new javax.swing.JTextField();
        diffButton = new javax.swing.JButton();
        projectButton = new javax.swing.JButton();
        bundleTree = new javax.swing.JScrollPane();
        diffPanel = new javax.swing.JPanel();

        setName(NbBundle.getMessage(BundleImportTopComponent.class, "BundleImportTopComponent.name")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(jLabel1, NbBundle.getMessage(BundleImportTopComponent.class, "BundleImportTopComponent.jLabel1.text")); // NOI18N
        jLabel1.setName(NbBundle.getMessage(BundleImportTopComponent.class, "BundleImportTopComponent.jLabel1.name")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(jLabel2, NbBundle.getMessage(BundleImportTopComponent.class, "BundleImportTopComponent.jLabel2.text")); // NOI18N
        jLabel2.setName(NbBundle.getMessage(BundleImportTopComponent.class, "BundleImportTopComponent.jLabel2.name")); // NOI18N

        bundleChangeFileTextField.setEditable(false);
        bundleChangeFileTextField.setText(NbBundle.getMessage(BundleImportTopComponent.class, "BundleImportTopComponent.bundleChangeFileTextField.text")); // NOI18N
        bundleChangeFileTextField.setName(NbBundle.getMessage(BundleImportTopComponent.class, "BundleImportTopComponent.bundleChangeFileTextField.name")); // NOI18N

        currentProjectFileTextField.setEditable(false);
        currentProjectFileTextField.setText(NbBundle.getMessage(BundleImportTopComponent.class, "BundleImportTopComponent.currentProjectFileTextField.text")); // NOI18N
        currentProjectFileTextField.setName(NbBundle.getMessage(BundleImportTopComponent.class, "BundleImportTopComponent.currentProjectFileTextField.name")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(diffButton, NbBundle.getMessage(BundleImportTopComponent.class, "BundleImportTopComponent.diffButton.text")); // NOI18N
        diffButton.setName(NbBundle.getMessage(BundleImportTopComponent.class, "BundleImportTopComponent.diffButton.name")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(projectButton, NbBundle.getMessage(BundleImportTopComponent.class, "BundleImportTopComponent.projectButton.text")); // NOI18N
        projectButton.setName(NbBundle.getMessage(BundleImportTopComponent.class, "BundleImportTopComponent.projectButton.name")); // NOI18N

        bundleTree.setName(NbBundle.getMessage(BundleImportTopComponent.class, "BundleImportTopComponent.bundleTree.name")); // NOI18N

        diffPanel.setName(NbBundle.getMessage(BundleImportTopComponent.class, "BundleImportTopComponent.diffPanel.name")); // NOI18N

        javax.swing.GroupLayout diffPanelLayout = new javax.swing.GroupLayout(diffPanel);
        diffPanel.setLayout(diffPanelLayout);
        diffPanelLayout.setHorizontalGroup(
            diffPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 0, Short.MAX_VALUE)
        );
        diffPanelLayout.setVerticalGroup(
            diffPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 223, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(diffPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(bundleTree)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 64, Short.MAX_VALUE)
                            .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(bundleChangeFileTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 283, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(diffButton))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(currentProjectFileTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 283, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(projectButton)))
                        .addGap(0, 182, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(bundleChangeFileTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(diffButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(currentProjectFileTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(projectButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(bundleTree, javax.swing.GroupLayout.PREFERRED_SIZE, 174, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(diffPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField bundleChangeFileTextField;
    private javax.swing.JScrollPane bundleTree;
    private javax.swing.JTextField currentProjectFileTextField;
    private javax.swing.JButton diffButton;
    private javax.swing.JPanel diffPanel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JButton projectButton;
    // End of variables declaration//GEN-END:variables
    @Override
    public void componentOpened() {
        // TODO add custom code on component opening
    }

    @Override
    public void componentClosed() {
        // TODO add custom code on component closing
    }

    void writeProperties(java.util.Properties p) {
        // better to version settings since initial version as advocated at
        // http://wiki.apidesign.org/wiki/PropertyFiles
        p.setProperty("version", "1.0");
        // TODO store your settings
    }

    void readProperties(java.util.Properties p) {
        String version = p.getProperty("version");
        // TODO read your settings according to their version
    }
}
